#include "stm32f10x.h"

//-----------------------------------------------------------------------------
//-------------------- CASETTE RX ---------------------------------------------
//-----------------------------------------------------------------------------

//#define SYSCLK_FREQ_72MHz  72000000

#define R1off GPIOA->BRR = GPIO_Pin_0
#define R1on GPIOA->BSRR = GPIO_Pin_0
#define R2off GPIOA->BRR = GPIO_Pin_1
#define R2on GPIOA->BSRR = GPIO_Pin_1
#define R3off GPIOA->BRR = GPIO_Pin_2
#define R3on GPIOA->BSRR = GPIO_Pin_2
#define R4off GPIOA->BRR = GPIO_Pin_3
#define R4on GPIOA->BSRR = GPIO_Pin_3
#define R5off GPIOA->BRR = GPIO_Pin_4
#define R5on GPIOA->BSRR = GPIO_Pin_4
#define R6off GPIOA->BRR = GPIO_Pin_5
#define R6on GPIOA->BSRR = GPIO_Pin_5
#define Rsafeoff GPIOA->BRR = GPIO_Pin_6
#define Rsafeon GPIOA->BSRR = GPIO_Pin_6
#define LED1off GPIOA->BRR = GPIO_Pin_11
#define LED1on GPIOA->BSRR = GPIO_Pin_11
#define LED2off GPIOA->BRR = GPIO_Pin_12
#define LED2on GPIOA->BSRR = GPIO_Pin_12
#define LEDinfooff GPIOC->BSRR = GPIO_Pin_13
#define LEDinfoon  GPIOC->BRR = GPIO_Pin_13
#define setHChigh   GPIOB->BRR = GPIO_Pin_7
#define setHClow    GPIOB->BSRR = GPIO_Pin_7
#define getadres    (0x0f & (~((GPIOB->IDR)>>8)))
#define getsettings (0x0f & (~((GPIOB->IDR)>>12)))


void GPIO_Config(void);
void NVIC_Config(void);
void USART_Config(void);
void RCC_Config(void);

void sendstring(char *string);
void searchbuffor(void);
void sendinfo(uint8_t *onoroff);
void ledinfoster(uint8_t *sterled);
void setsetting(void);
void Flash_read(void);
void Flash_write(void);

volatile uint32_t timerled, timersetting, timer;
volatile uint8_t wskbuff, flagaHC;
volatile unsigned char bufforHC[200];
uint8_t adress='A', onoroff=0, sterled=0, elmdrgadres, canal;
uint8_t status[6]={0,0,0,0,0,0};
uint16_t tempcanal;

//-----------------------------------------------------------------------
//---------- Definicje obszarow flash uC---------------------------------
uint32_t EraseCounter = 0x00, Address = 0x00;
uint32_t NbrOfPage = 0x00;
volatile FLASH_Status FLASHStatus=FLASH_COMPLETE;

#define BaseAdresFlash 0x08000000

//ofsety osobno dla funkcji - dla zapamietywania wartosci kalibracyjnych touchapnelu
#define OffsetNazwy 0xf400
#define BANK1_WRITE_START_ADDR  ((uint32_t)0x0800f400)  //Ustawienie 1kb
#define BANK1_WRITE_END_ADDR    ((uint32_t)0x0800f800)
#define FLASH_PAGE_SIZE         ((uint16_t)0x400)
//-------------------------------------------------------------------------

int main(void)
{

	RCC_Config();
	NVIC_Config();
	GPIO_Config();
	USART_Config();

	 //Inicjalizacja zegrar systemowego systick
		if (SysTick_Config_Mod(SysTick_CLKSource_HCLK_Div8, 900)) //przerwanie co 0,1ms
		{
			while(1);		// W razie bledu petla nieskonczona
		}

		adress=getadres;

		        Flash_read(); //odczytanie kanalu z pamieci flash
				tempcanal=getsettings;

				if(canal != tempcanal)
				{
					canal=getsettings;
					Flash_write();  //zapis nowego kanalu do pamieci flash
					setsetting();   //funkcja powowdujaca ustawienie odpowiedniego kanalu
				}

				Flash_read(); //odczytanie kanalu z pamieci flash

		Rsafeon; // zalaczenie przekaznika NC

		//Petla nieskonczonosci
		while(1)
		{
				if(flagaHC)  //jezeli odebrano nowy pakiet danych - nalezy przeszukac buffor
				{
					flagaHC=0;

					 searchbuffor(); //funkcja przeszukujaca bufor oraz zmieniajaca stan przekaznikow
				}

			    sendinfo(&onoroff); //przeslanie informacji o zalaczeniu lub wylaczeniu przekaznika
			    ledinfoster(&sterled);

				if((adress!=getadres) && !elmdrgadres)
						{
							elmdrgadres=200;
							adress=getadres;
						}
				 else if(elmdrgadres) elmdrgadres--;
		}


}

void USART_Config(void)
{

	   //Konfiguracja USART1
	    USART_InitTypeDef  USART_InitStructure;

	    USART_InitStructure.USART_BaudRate =9600;
	    USART_InitStructure.USART_WordLength = USART_WordLength_8b;                     //Dlugosc slowa = 8 bitow
	    USART_InitStructure.USART_StopBits = USART_StopBits_1;                          //1 bit stopu
	    USART_InitStructure.USART_Parity = USART_Parity_No;                             //Brak kontroli parzystosci
	    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Kontrola przeplywu danych (brak)
	    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	                //Tryb pracy
	    USART_Init(USART1, &USART_InitStructure);
	    USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);  	                       	//zalaczenie przerwania od USART
	    USART_Cmd(USART1, ENABLE);  //zalaczenie konfiguracji
}

void NVIC_Config(void)
{
	NVIC_InitTypeDef   NVIC_InitStructure;

	NVIC_InitStructure.NVIC_IRQChannel =SysTick_IRQn ; //tutaj trzeba zwrocic uwage na definicje w pliu stm32f10x.h
	//******************************************************************************************************************
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);


  	 NVIC_InitStructure.NVIC_IRQChannel =USART1_IRQn ; //tutaj trzeba zwrocic uwage na definicje w pliu stm32f10x.h
  		//******************************************************************************************************************
  	 NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  	 NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  	 NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	 NVIC_Init(&NVIC_InitStructure);
}

void GPIO_Config(void)
{
  //konfigurowanie portow GPIO
   GPIO_InitTypeDef  GPIO_InitStructure;

  //UART
  //PA9 - Tx
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	//PA10 - Rx
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	//Obsluga przekaznikow
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	//Obsluga LED1, 2
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11 | GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIOA->BRR = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_11 | GPIO_Pin_12;

	//Obsluga LED info
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIOC->BSRR = GPIO_Pin_13;

    //Sterowanie HC-12 SET
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    GPIOB->BRR = GPIO_Pin_7;

    //Ustawienie portow odpowiedzialnych za wybor adresu oraz ustawien
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 |  GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
}


void RCC_Config(void)
//konfigurowanie sygnalow taktujacych
{

  RCC_DeInit();                                          //Reset ustawien RCC
  RCC_HSEConfig(RCC_HSE_ON);                             //Wlaczenie HSE


	RCC_HCLKConfig(RCC_SYSCLK_Div1);                     //ustaw HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div4);                      //ustaw PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div4);                      //ustaw PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); //ustaw PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz

    RCC_PLLCmd(ENABLE);                                  //wlacz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){}  //odczekaj na poprawne uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           //ustaw PLL jako zrodlo sygnalu zegarowego
    while(RCC_GetSYSCLKSource() != 0x08){}//odczekaj az PLL bedzie sygnalem zegarowym systemu

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE); //zalaczenie wyjsc alternatywnych

    /*kod zwiazany z konfiguracja sygnalow zegarowych potrzebnych w programie peryferiow*/
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);//wlacz taktowanie USART1
}

//------------------------------------------------------------------------------------------------------------------
//Funkcja wysylajaca wiadomosci w postaci zmiennej lancuchowej
void sendstring( char *string)
{
	 char *s;

	s=string;
	while(*s)
	{
		while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET)
		{

		}
		    	USART_SendData(USART1, (uint16_t)*s);
				s++;
	}
	while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET); //odczekanie az bufor do wysylania bedzie pusty
}

//Funkcja w ktorej nastepuje przeszukanie buffora oraz steorwanie przekaznikami
void searchbuffor(void)
{
	uint8_t k, l, m, n, o, a=0;


	for(k=0; k<=199; k++)
	{
		l=k;
		m=k+1;
		n=k+2;
		o=k+3;

		if(m>199) m=m-200;
		if(n>199) n=n-200;
		if(o>199) o=o-200;


		if((bufforHC[l]==adress) && (bufforHC[o]=='k'))
		{
			if(bufforHC[m]==bufforHC[n])
			{
				a=bufforHC[m]-0x30;


			switch(a)
			{

			case 1:
					{
						    if(!status[0])
						    {
						    	status[0]=1;
						    	R1on;
						    	onoroff=1;   //flaga informujaca o zalaczeniu przekaznika
						    	sterled+=2;
						    }
						    else
						    {
						    	status[0]=0;
						    	R1off;
						    	onoroff=2;   //flaga informujaca o wylaczeniu przekaznika
						    	sterled+=2;
						    }
							break;
					}
			case 2:
					{
					    if(!status[1])
							{
								status[1]=1;
								R2on;
								onoroff=1;   //flaga informujaca o zalaczeniu przekaznika
								sterled+=2;
							 }
							 else
							 {
								status[1]=0;
								R2off;
								onoroff=2;   //flaga informujaca o wylaczeniu przekaznika
								sterled+=2;
						   }
							break;
					}
			case 3:
					{
						if(!status[2])
						{
								status[2]=1;
								R3on;
								onoroff=1;   //flaga informujaca o zalaczeniu przekaznika
								sterled+=2;
						}
						 else
						 {
								status[2]=0;
								R3off;
								onoroff=2;   //flaga informujaca o wylaczeniu przekaznika
								sterled+=2;
						 }
							break;
					}
			case 4:
					{
						if(!status[3])
						{
								status[3]=1;
								R4on;
								onoroff=1;   //flaga informujaca o zalaczeniu przekaznika
								sterled+=2;
						}
						 else
						 {
								status[3]=0;
								R4off;
								onoroff=2;   //flaga informujaca o wylaczeniu przekaznika
								sterled+=2;
						 }
							break;
					}
			case 5:
					{

						if(!status[4])
						{
								status[4]=1;
								R5on;
								onoroff=1;   //flaga informujaca o zalaczeniu przekaznika
								sterled+=2;
						}
						 else
						{
									status[4]=0;
									R5off;
									onoroff=2;   //flaga informujaca o wylaczeniu przekaznika
									sterled+=2;
					    }
							break;
					}
			case 6:
					{
						if(!status[5])
						{
						        	status[5]=1;
									R6on;
									onoroff=1;   //flaga informujaca o zalaczeniu przekaznika
									sterled+=2;
						}
						else
						 {
									status[5]=0;
									R6off;
									onoroff=2;   //flaga informujaca o wylaczeniu przekaznika
									sterled+=2;
						 }
							break;
					}
			case 7:
					{
						    Rsafeoff;
							onoroff=3;   //flaga informujaca o wylaczeniu przekaznika
							sterled+=2;
							break;
					}
			case 8:
					{
							Rsafeon;
							onoroff=4;   //flaga informujaca o wylaczeniu przekaznika
							sterled+=2;
							break;
					}
			}

			//wyskasowanie bufora odbiorczego
			bufforHC[l]=0x00;
			bufforHC[m]=0x00;
			bufforHC[n]=0x00;
			bufforHC[o]=0x00;
		}
		}
	}
}

//Funkcja wysylajaca informacje o zalaczeniu lub wylaczeniu przekaznika
void sendinfo(uint8_t *onoroff)
{

	  char informacja[4];

	if(*onoroff)
	{
		informacja[0]=adress;
		informacja[1]='s';
		informacja[2]='k';
		informacja[3]=0x00;

		switch(*onoroff)
		{
			case 1:
			{
				informacja[1]='o';
				sendstring(informacja);
				break;
			}
			case 2:
			{
				informacja[1]='f';
				sendstring(informacja);
				break;
			}
			case 3:
			{
				informacja[1]='a';
				sendstring(informacja);
				break;
			}
			case 4:
			{
				informacja[1]='r';
				sendstring(informacja);
				break;
			}
		}
		*onoroff=0;
	}
}
// Funkcja sterujaca infoledem
void ledinfoster(uint8_t *sterled)
{
	if(*sterled && (!timerled))
	{
		timerled=2000;

		*sterled=(*sterled)-1;

		if((*sterled)%2)
		{
			LEDinfoon;
		}
		else LEDinfooff;
	}
}

//Funkcja ustawiajaca ustawienie kanalu
void setsetting(void)
{
	uint8_t temp=0;
	uint8_t tempcanal;
	char canalnumber[5];

	timersetting=20000;
	setHClow;


	while(timersetting)
	{
		if(!timerled)
		{
			if(!temp)
			{
				temp=1;
				LED1on;
				LED2off;
			}
			else
			{
				temp=0;
				LED1off;
				LED2on;
			}

			timerled=2000;
		}
	}
//W tym miejscu nastepuje wyslanie komend AT

	tempcanal=canal*7;
	canalnumber[0]=tempcanal/100;
	canalnumber[1]=tempcanal-(100*canalnumber[0]);
	canalnumber[1]=canalnumber[1]/10;
	canalnumber[2]=tempcanal%10;
	canalnumber[3]=0x00;

	if((!canalnumber[0]) && (!canalnumber[1]) && (!canalnumber[2]))
	{
		canalnumber[2]=0x01;
	}

	canalnumber[0]+=0x30;
	canalnumber[1]+=0x30;
	canalnumber[2]+=0x30;

	sendstring("AT+C");
	sendstring(canalnumber);
	sendstring("\n\r");


	timersetting=2000;
	while(timersetting); //odczekanie 200ms po wyslaniu komendy at

	setHChigh;
	timersetting=20000;
	while(timersetting)
	{
		if(!timerled)
		{
			if(!temp)
			{
				temp=1;
				LED1on;
				LED2on;
			}
			else
			{
				temp=0;
				LED1off;
				LED2off;
			}

			timerled=2000;
		}
	}
	LED1off;
	LED2off;
}

//-----------------------------------------------------------------------------
//---------- Funkcje obslugi pamieci flash ------------------------------------

void Flash_read(void)
{
	uint32_t *p;

	p=(uint32_t *)(BaseAdresFlash+OffsetNazwy);
	canal=(uint8_t)*p; //przepisanie wartosci z flash
}


void Flash_write(void)
{

	FLASH_Unlock();

	NbrOfPage = (BANK1_WRITE_END_ADDR - BANK1_WRITE_START_ADDR) / FLASH_PAGE_SIZE;

	FLASH_ClearFlag(FLASH_FLAG_EOP|FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR);


  // Wykasowanie pamieci
  for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (FLASHStatus == FLASH_COMPLETE); EraseCounter++)
  {
    FLASHStatus = FLASH_ErasePage(BANK1_WRITE_START_ADDR + (FLASH_PAGE_SIZE * EraseCounter));
  }


   while(FLASH_COMPLETE!=FLASH_ProgramWord(BaseAdresFlash + OffsetNazwy, (uint32_t)canal))
  {
  }

	FLASH_Lock();  //zablokowanie dostepu do pamieci flash

}
