#include "stm32f10x.h"

//---------------------------------------------------------------------
//--------------- CASETTE TX ------------------------------------------
//---------------------------------------------------------------------

//#define SYSCLK_FREQ_72MHz  72000000
#define setHChigh   GPIOB->BRR = GPIO_Pin_7;
#define setHClow    GPIOB->BSRR = GPIO_Pin_7;
#define getadres    (0x0f & (~((GPIOB->IDR)>>8)))
#define getsettings (0x0f & (~((GPIOB->IDR)>>12)))
#define wPB1        !((GPIOA->IDR) & GPIO_Pin_0)
#define wPB2        !((GPIOA->IDR) & GPIO_Pin_1)
#define wPB3        !((GPIOA->IDR) & GPIO_Pin_2)
#define wPB4        !((GPIOA->IDR) & GPIO_Pin_3)
#define wPB5        !((GPIOA->IDR) & GPIO_Pin_4)
#define wPB6        !((GPIOA->IDR) & GPIO_Pin_5)
#define wPBsafe      ((GPIOA->IDR) & GPIO_Pin_6)
#define LEDinfooff    GPIOC->BSRR = GPIO_Pin_13
#define LEDinfoon      GPIOC->BRR = GPIO_Pin_13

void GPIO_Config(void);
void NVIC_Config(void);
void USART_Config(void);
void RCC_Config(void);

void controlbuttons(void);
void sendstring( char *string);
void ledinfoster(uint8_t *sterled);
void searchbuffor(void);
void setsetting(void);
void Flash_read(void);
void Flash_write(void);

volatile uint32_t timerled, timersetting, timer;
volatile uint8_t wskbuff, flagaHC;
volatile unsigned char bufforHC[200];
uint8_t adress='A', sterled, elmdrgadres, canal, saveflash;
uint16_t tempcanal;

//-----------------------------------------------------------------------
//---------- Definicje obszarow flash uC---------------------------------
uint32_t EraseCounter = 0x00, Address = 0x00;
uint32_t NbrOfPage = 0x00;
volatile FLASH_Status FLASHStatus=FLASH_COMPLETE;

#define BaseAdresFlash 0x08000000

//ofsety osobno dla funkcji - dla zapamietywania wartosci kalibracyjnych touchapnelu
#define OffsetNazwy 0xf400
#define BANK1_WRITE_START_ADDR  ((uint32_t)0x0800f400)  //Ustawienie 1kb
#define BANK1_WRITE_END_ADDR    ((uint32_t)0x0800f800)
#define FLASH_PAGE_SIZE         ((uint16_t)0x400)
//-------------------------------------------------------------------------

int main(void)
{

	RCC_Config();
	NVIC_Config();
	GPIO_Config();
	USART_Config();

	 //Inicjalizacja zegrar systemowego systick
		if (SysTick_Config_Mod(SysTick_CLKSource_HCLK_Div8, 900)) //przerwanie co 0,1ms
		{
			while(1);		// W razie bledu petla nieskonczona
		}

		adress=getadres;

		Flash_read(); //odczytanie kanalu z pamieci flash
		tempcanal=getsettings;

		if(canal != tempcanal)
		{
			canal=getsettings;
			Flash_write();  //zapis nowego kanalu do pamieci flash

			setsetting();  //ustawienie odpowiedniego kanalu

		}

		Flash_read(); //odczytanie kanalu z pamieci flash

		//Petla nieskonczonosci
		while(1)
		{

			controlbuttons(); //funkcja obslugujaca przyciski

			if(flagaHC)  //jezeli odebrano nowy pakiet danych - nalezy przeszukac buffor
			{
				flagaHC=0;
				searchbuffor(); //funkcja przeszukujaca bufor oraz zmieniajaca stan przekaznikow
			}

			ledinfoster(&sterled);

			if((adress!=getadres) && !elmdrgadres)
			{
				elmdrgadres=200;
				adress=getadres;
			}
			else if(elmdrgadres) elmdrgadres--;
		}


}

void USART_Config(void)
{

	  //Konfiguracja USART1
	    USART_InitTypeDef  USART_InitStructure;


	    //Wpisywanie ilosci bodow

	    USART_InitStructure.USART_BaudRate =9600;
	    USART_InitStructure.USART_WordLength = USART_WordLength_8b;                     //Dlugosc slowa = 8 bitow
	    USART_InitStructure.USART_StopBits = USART_StopBits_1;                          //1 bit stopu
	    USART_InitStructure.USART_Parity = USART_Parity_No;                             //Brak kontroli parzystosci
	    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Kontrola przeplywu danych (brak)
	    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	                //Tryb pracy
	    USART_Init(USART1, &USART_InitStructure);
	    USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);  	                       	//zalaczenie przerwania od USART
	    USART_Cmd(USART1, ENABLE);  //zalaczenie konfiguracji
}

void NVIC_Config(void)
{
	NVIC_InitTypeDef   NVIC_InitStructure;

	NVIC_InitStructure.NVIC_IRQChannel =SysTick_IRQn ; //tutaj trzeba zwrocic uwage na definicje w pliu stm32f10x.h
	//******************************************************************************************************************
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);


  	 NVIC_InitStructure.NVIC_IRQChannel =USART1_IRQn ; //tutaj trzeba zwrocic uwage na definicje w pliu stm32f10x.h
  		//******************************************************************************************************************
  	 NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  	 NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  	 NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	 NVIC_Init(&NVIC_InitStructure);
}

void GPIO_Config(void)
{
  //konfigurowanie portow GPIO
   GPIO_InitTypeDef  GPIO_InitStructure;

  //UART
  //PA9 - Tx
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	//PA10 - Rx
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	//Obsluga przyciskow
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

	//Obsluga LED info
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	GPIOC->BSRR = GPIO_Pin_13;

	//Sterowanie HC-12 SET
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	GPIOB->BRR = GPIO_Pin_7;

	//Ustawienie portow odpowiedzialnych za wybor adresu oraz ustawien
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 |  GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}


void RCC_Config(void)
//konfigurowanie sygnalow taktujacych
{

  RCC_DeInit();                                          //Reset ustawien RCC
  RCC_HSEConfig(RCC_HSE_ON);                             //Wlaczenie HSE


	RCC_HCLKConfig(RCC_SYSCLK_Div1);                     //ustaw HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div4);                      //ustaw PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div4);                      //ustaw PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); //ustaw PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz

    RCC_PLLCmd(ENABLE);                                  //wlacz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){}  //odczekaj na poprawne uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           //ustaw PLL jako zrodlo sygnalu zegarowego
    while(RCC_GetSYSCLKSource() != 0x08){}//odczekaj az PLL bedzie sygnalem zegarowym systemu

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE); //zalaczenie wyjsc alternatywnych

         /*kod zwiazany z konfiguracja sygnalow zegarowych potrzebnych w programie peryferiow*/
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);

		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);//wlacz taktowanie USART1

}

//------------------------------------------------------------------------------------------------------------------
//Funkcja wysylajaca wiadomosci w postaci zmiennej lancuchowej
void sendstring( char *string)
{
	 char *s;

	s=string;
	while(*s)
	{
		while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET)
		{

		}
		    	USART_SendData(USART1, (uint16_t)*s);
				s++;
	}
	while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET); //odczekanie az bufor do wysylania bedzie pusty
}

//Funkcja kontrolujaca stan przyciskow
void controlbuttons(void)
{
	static uint8_t elmdrg1=0, elmdrg2=0, elmdrg3=0, elmdrg4=0, elmdrg5=0, elmdrg6=0, safe=0x0f, tempsafe=0xff, elmdrgsafe=0;

	 char message[5];

	message[0]=adress;
	message[3]='k';
	message[4]=0x00;   //znak konczacy null

	if(wPB1 && !elmdrg1)
	{
		elmdrg1=50;

		message[1]='1';
		message[2]='1';

		sendstring(message);

	}
	else if(!wPB1 && elmdrg1) elmdrg1--;

	if(wPB2 && !elmdrg2)
		{
			elmdrg2=50;

			message[1]='2';
			message[2]='2';

			sendstring(message);

		}
		else if(!wPB2 && elmdrg2) elmdrg2--;

	if(wPB3 && !elmdrg3)
		{
			elmdrg3=50;

			message[1]='3';
			message[2]='3';

			sendstring(message);

		}
		else if(!wPB3 && elmdrg3) elmdrg3--;

	if(wPB4 && !elmdrg4)
		{
			elmdrg4=50;

			message[1]='4';
			message[2]='4';

			sendstring(message);

		}
	else if(!wPB4 && elmdrg4) elmdrg4--;

	if(wPB5 && !elmdrg5)
		{
			elmdrg5=50;

			message[1]='5';
			message[2]='5';

			sendstring(message);

		}
	else if(!wPB5 && elmdrg5) elmdrg5--;

	if(wPB6 && !elmdrg6)
		{
			elmdrg6=50;

			message[1]='6';
			message[2]='6';

			sendstring(message);
		}
	else if(!wPB6 && elmdrg6) elmdrg6--;


		if(wPBsafe && (!elmdrgsafe))
		{
			safe=1;
			elmdrgsafe=50;
		}
		else if(!wPBsafe && (!elmdrgsafe))
		{
			safe=0;
			elmdrgsafe=50;
		}

		if(elmdrgsafe) elmdrgsafe--;

		if(tempsafe!=safe)
		{
			 tempsafe=safe;
			//zminana stanu przekaznika 7 czyli safe

			if(safe==1)
			{
				message[1]='7';
				message[2]='7';

				sendstring(message);
			}
			else
			{
				message[1]='8';
				message[2]='8';

				sendstring(message);
			}
		}

}

//Funkcja sluzaca do przeszukania bufora odbiorczego
void searchbuffor(void)
{
	uint8_t k, l, m, n;


	for(k=0; k<=199; k++)
	{
		l=k;
		m=k+1;
		n=k+2;

		if(m>199) m=m-200;
		if(n>199) n=n-200;


		if((bufforHC[l]==adress) && (bufforHC[n]=='k'))
		{
			switch(bufforHC[m])
			{
				case 'o':
				{
					sterled+=3;
					break;
				}
				case 'f':
				{
					sterled+=5;
					break;
				}
				case 'a':
				{
					sterled+=7;
					break;
				}
				case 'r':
				{
					sterled+=9;
					break;
				}
			}
			//wyskasowanie bufora odbiorczego
			bufforHC[l]=0x00;
			bufforHC[m]=0x00;
			bufforHC[n]=0x00;
		}
	}
}

// Funkcja sterujaca infoledem
void ledinfoster(uint8_t *sterled)
{
	if(*sterled && (!timerled))
	{
		timerled=2000;
		*sterled=(*sterled)-1;

		if((*sterled)%2)
		{
			LEDinfoon;
		}
		else LEDinfooff;

	}
}

//Funkcja ustawiajaca ustawienie kanalu
void setsetting(void)
{
	uint8_t temp=0;
	uint8_t tempcanal;
	 char canalnumber[5];

	timersetting=20000;
	setHClow;

	while(timersetting)
	{
		if(!timerled)
		{
			timerled=2000;

			if(!temp)
			{
				temp=1;
				LEDinfooff;
			} else
			{
				temp=0;
				LEDinfoon;
			}
		}
	}
	LEDinfooff;
//W tym miejscu nastepuje wyslanie komendy AT



	tempcanal=canal*7;
	canalnumber[0]=tempcanal/100;
	canalnumber[1]=tempcanal-(100*canalnumber[0]);
	canalnumber[1]=canalnumber[1]/10;
	canalnumber[2]=tempcanal%10;
	canalnumber[3]=0x00;

	if((!canalnumber[0]) && (!canalnumber[1]) && (!canalnumber[2]))
	{
		canalnumber[2]=0x01;
	}

	canalnumber[0]+=0x30;
	canalnumber[1]+=0x30;
	canalnumber[2]+=0x30;

	sendstring("AT+C");
	sendstring(canalnumber);
	sendstring("\n\r");

	timersetting=2000;
	while(timersetting); //odczekanie 200ms po wyslaniu komendy at

	setHChigh;
	timersetting=20000;
	while(timersetting)
	{
		if(!timerled)
		{
			timerled=2000;

			if(!temp)
			{
				temp=1;
				LEDinfooff;
			} else
			{
				temp=0;
				LEDinfoon;
			}
		}
	}
	LEDinfooff;

}

//-----------------------------------------------------------------------------
//---------- Funkcje obslugi pamieci flash ------------------------------------


void Flash_read(void)
{
	uint32_t *p;

	p=(uint32_t *)(BaseAdresFlash+OffsetNazwy);
	canal=(uint8_t)*p; //przepisanie wartosci z flash
}


void Flash_write(void)
{

	FLASH_Unlock();

	NbrOfPage = (BANK1_WRITE_END_ADDR - BANK1_WRITE_START_ADDR) / FLASH_PAGE_SIZE;

	FLASH_ClearFlag(FLASH_FLAG_EOP|FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR);


  // Wykasowanie pamieci
  for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (FLASHStatus == FLASH_COMPLETE); EraseCounter++)
  {
    FLASHStatus = FLASH_ErasePage(BANK1_WRITE_START_ADDR + (FLASH_PAGE_SIZE * EraseCounter));
  }


   while(FLASH_COMPLETE!=FLASH_ProgramWord(BaseAdresFlash + OffsetNazwy, (uint32_t)canal))
  {
  }

	FLASH_Lock();  //zablokowanie dostepu do pamieci flash

}
